from typing import List, Tuple

from tpcwj.utils import Bytes
from tpcwj.payload import Payload


class Unpacker:
    @classmethod
    def unpack(cls, image_datas: List[Bytes]) -> Tuple[str, Bytes]:
        file_name = ''
        file_data = Bytes()
        file_slices = []
        for image_data in image_datas:
            image_payload = Payload.extract_payload(image_data)
            file_slices.append(image_payload)
        file_slices.sort()
        file_name = file_slices[0].meta.name
        for file_slice in file_slices:
            file_data = file_data+file_slice.data
        return (file_name, file_data)
